
/**************************************************************************
**  (c) Copyright 2002, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : database.h
**      SYSTEM NAME    : 
**      VERSION NUMBER : $Revision: 1.1 $
**
**  DESCRIPTION      :  Classes to provide an abstract layer on the Gnucomo
**                      database.
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Sep 10, 2002
**      LAST UPDATE     : 
**      MODIFICATIONS   : 
**************************************************************************/

/*****************************
   $Log: database.h,v $
   Revision 1.1  2002/10/05 10:25:49  arjen
   Creation of gcm_input and a first approach to a web interface

*****************************/

/* static const char *RCSID = "$Id: database.h,v 1.1 2002/10/05 10:25:49 arjen Exp $"; */

#include <libpq++/pgdatabase.h>
#include "gnucomo_config.h"

/*
///////////////////////////////////////////////////////////////////////////
//  NAME           : gnucomo_database
//  BASECLASS      : configuration
//  MEMBERS        :
//  OPERATORS      :
//  METHODS        : Database - Obtain the database access string
//
//  DESCRIPTION    : 
//
//  RELATIONS      :
//  SEE ALSO       :
//  LAST MODIFIED  : Sep 16, 2002
///////////////////////////////////////////////////////////////////////////
*/

class gnucomo_database
{
   gnucomo_config    *cfg;
   PgDatabase        *db;

public:

   gnucomo_database()
   {
      cfg = 0;
      db  = 0;
   }

   gnucomo_database(gnucomo_config *c);  // Use the configuration to connect to the database

   //  Low-level database access functions

   int Query(String qry)
   {
      ExecStatusType  result;

      result = db->Exec(qry);
      if (result == PGRES_TUPLES_OK || result == PGRES_COMMAND_OK)
      {
         return db->Tuples();
      }
      else
      {
         cerr << "Database query error: " << db->ErrorMessage() << "\n";
         return -1;
      }
   }

   //  Return the objectid of the host given its name.

   String find_host(const String hostname);
};

